]> git.pld-linux.org Git - packages/rpm-build-macros.git/blame_incremental - rpm.macros
- restart php-fpm if installed
[packages/rpm-build-macros.git] / rpm.macros
... / ...
CommitLineData
1# $Revision$, $Date$
2# PLD Linux rpm macros
3
4%epoch 0
5%x8664 x86_64 amd64 ia32e
6
7# kernel compiler
8%kgcc %{__cc}
9%kgcc_package gcc
10
11# compiler version
12%cc_version %{expand:%%global cc_version %(%{__cc} -dumpversion || echo ERROR)}%cc_version
13%cxx_version %{expand:%%global cxx_version %(%{__cxx} -dumpversion || echo ERROR)}%cxx_version
14
15%__rm /bin/rm --interactive=never
16
17# Build system path macros.
18%__autoconf autoconf %{?debug:-Wall}
19%__automake automake -a -c -f --foreign
20%__autopoint autopoint --force
21
22# add parallel build flags: -jN
23#
24# if you want to disable parallel build do (replace %% with %)
25# echo '%%_smp_mflags %%{nil}' >> ~/.rpmmacros
26#
27%__make make %{?_smp_mflags}
28%__scons scons %{?_smp_mflags}
29%__waf waf %{?_smp_mflags}
30%__cmake cmake %{?_smp_mflags}
31
32%_smp_mflags %(_NCPUS=$(/usr/bin/getconf _NPROCESSORS_ONLN); \\\
33 [ "$_NCPUS" -gt 1 ] && echo "-j$(($_NCPUS * 2))")
34
35%__gettextize { \
36 if grep -qs 'AM_GNU_GETTEXT.*external' configure.{ac,in} ; then \
37 gettextize --copy --force --no-changelog; \
38 else \
39 gettextize --copy --force --no-changelog --intl; \
40 fi; \
41 if [ ! -f po/Makevars ]; then \
42 cp -f po/Makevars{.template,}; \
43 fi; \
44}
45
46%__glib_gettextize glib-gettextize --copy --force
47%__gnome_doc_common gnome-doc-common --copy
48%__gnome_doc_prepare gnome-doc-prepare --copy --force
49%__gtkdocize gtkdocize --copy
50%__intltoolize intltoolize --copy --force
51%__libtoolize libtoolize --copy --force --install
52
53# Path to top of build area.
54%_topdir %{expand:%%global _topdir %(test -d ../SPECS -a -d ../SOURCES && (cd ..; pwd) || echo $HOME/rpm)}%_topdir
55
56# The number of cvs changelog entries kept when building package.
57%_buildchangelogtruncate 20
58
59%dependencytracking %{nil}
60
61# Relations between package names that cause dependency loops
62# with legacy packages that cannot be fixed. Relations are
63# specified as
64# p>q
65# where package p has a Requires: on something that package q Provides:
66#
67# XXX Note: that there cannot be any whitespace within the string "p>q",
68# and that both p and q are package names (i.e. no version/release).
69%_dependency_whiteout %{nil}
70
71#-----------------------------------------------------------------
72#
73# (re)definition of %{rpm*flags} with %filterout_* support
74# BuildRequires: awk
75# BuildRequires: rpmbuild(macros) >= 1.315
76#
77# Flags specified in %filterout_* are removed from %rpm*flags, exactly:
78# %rpmcflags = %optflags - %filterout - %filterout_c - %filterout_ld
79# %rpmcxxflags = %optflags - %filterout - %filterout_cxx - %filterout_ld
80# %rpmcppflags = %optcppflags - %filterout - %filterout_cpp - %filterout_ld
81# %rpmldflags = %optldflags - %filterout_ld
82#
83# Regular expressions are supported, but to avoid some character be treated
84# as regular expression it must be escaped twice.
85
86%filter_out \
87 for (i = 1; i in I; i++) { A=0; \
88 for (f in F) { \
89 if (I[i] ~ "^" F[f] "$") A=1; \
90 }; \
91 if (!A) printf(I[i] FS); \
92 }
93
94%rpmcflags %(awk 'BEGIN {
95 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
96 split("%{?filterout} %{?filterout_c} %{?filterout_ld}",F);
97 %{filter_out}
98}')
99
100%rpmcxxflags %(awk 'BEGIN {
101 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
102 split("%{?filterout} %{?filterout_cxx} %{?filterout_ld}",F);
103 %{filter_out}
104}')
105
106%rpmcppflags %(awk 'BEGIN {
107 split("%{?debug:%debugcppflags}%{!?debug:%optcppflags}%{?debuginfocppflags}",I);
108 split("%{?filterout} %{?filterout_cpp} %{?filterout_cpp}",F);
109 %{filter_out}
110}')
111
112%rpmldflags %(awk 'BEGIN {
113 split("%{?optldflags}",I);
114 split("%{?filterout_ld}",F)
115 %{filter_out}
116}')
117
118# rpmldflags with stripped -Wl, -- in the form flags have to be passed to 'ld'
119# but, don't use it, better use gcc as linker
120%ld_rpmldflags %(awk 'BEGIN {
121 split("%{rpmldflags}",F);
122 for (f in F) {
123 s = F[f];
124 if (s ~ /^-Wl,/) {
125 s = substr(s,5);
126 gsub(/,/," ",s);
127 };
128 printf(s FS);
129 };
130}')
131
132#-----------------------------------------------------------------
133#
134# Generate a command which cleans environment, leaving only the
135# most important variables.
136# If any spec requires any additional environment it should
137# redefine %_preserve_env in following manner:
138#
139# # ADDITIONAL_VAR is required because [a good reason here]
140# %define _preserve_env ADDITIONAL_VAR
141
142%_preserve_env_base PATH HOME TMP TMPDIR SSH_AUTH_SOCK
143
144# "env -i" must end in first line of expaned macros because it's used as first line of shell script (#! env...)
145%_clean_env %{!?_preserve_env:%global _preserve_env %{nil}}%{expand:%%global _preserve_env %{_preserve_env} %_preserve_env_base} env -i %(awk -vq="'" -vqq="\\"'\\"" -vq2q="'\\"'" 'BEGIN {
146 split("%{?_preserve_env}", P);
147 for (i in P) {
148 p = P[i];
149 if (!ENVIRON[p] || d[p]) {
150 continue;
151 }
152 d[p] = 1;
153 split(ENVIRON[p], V, "");
154 val = p "=";
155 for (j = 1; j in V; j++) {
156 v = V[j];
157 if (v == q)
158 v = qq;
159 else if (v == "\\"")
160 v = q2q;
161 else if (v == "\\\\")
162 v = "\\\\\\\\";
163 else
164 gsub("[^a-zA-Z0-9/:._-]", "\\"&\\"", v);
165 val = val "" v;
166 }
167 printf(val " ");
168 }
169}')
170
171#-----------------------------------------------------------------
172%configure2_13 { \
173 if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
174 LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
175 CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
176 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
177 FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
178 FCFLAGS="${FCFLAGS:-%rpmcflags}" ; export FCFLAGS ; \
179 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" ; export CPPFLAGS ; \
180 %{?__cc:CC="%{__cc}" ; export CC ; } \
181 %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
182 %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
183 --host=%{_target_platform} \
184 --prefix=%{_prefix} \
185 --exec-prefix=%{_exec_prefix} \
186 --bindir=%{_bindir} \
187 --sbindir=%{_sbindir} \
188 --sysconfdir=%{_sysconfdir} \
189 --datadir=%{_datadir} \
190 --includedir=%{_includedir} \
191 --libdir=%{_libdir} \
192 --libexecdir=%{_libexecdir} \
193 --localstatedir=%{_localstatedir} \
194 --sharedstatedir=%{_sharedstatedir} \
195 --mandir=%{_mandir} \
196 --infodir=%{_infodir} \
197 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
198 %{dependencytracking} \
199}
200
201%__cmake /usr/bin/cmake
202%cmake { \
203CC="%{__cc}" \
204CXX="%{__cxx}" \
205CFLAGS="%{rpmcflags}" \
206CXXFLAGS="%{rpmcxxflags}" \
207LDFLAGS="%{rpmldflags}" \
208%{__cmake} \
209}
210
211# override __scons to add -j4 in your ~/.rpmmacros for parallel make
212%__scons /usr/bin/scons
213%scons { \
214%{__scons} \
215 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
216 CFLAGS="${CFLAGS:-%rpmcflags}" \
217 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
218 FFLAGS="${FFLAGS:-%rpmcflags}" \
219 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
220 %{?__cc:CC="%{__cc}"} \
221 %{?__cxx:CXX="%{__cxx}"} \
222 libsuffix=%{_lib} \
223 prefix=%{_prefix} \
224}
225
226# waf. see waf.spec
227# override __waf to add -j4 in your ~/.rpmmacros for parallel make
228%__waf /usr/bin/waf
229%waf { \
230CC="%{__cc}" \
231CXX="%{__cxx}" \
232CPP="%{__cpp}" \
233CFLAGS="%{rpmcflags}" \
234CXXFLAGS="%{rpmcxxflags}" \
235%{__waf} \
236}
237
238#----------------------------------------------------------------
239#%configure_cache 0
240%configure_cache_file %{buildroot}.configure.cache
241
242%configure {./configure \
243 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
244 CFLAGS="${CFLAGS:-%rpmcflags}" \
245 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
246 FFLAGS="${FFLAGS:-%rpmcflags}" \
247 FCFLAGS="${FCFLAGS:-%rpmcflags}" \
248 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
249 %{?__cc:CC="%{__cc}"} \
250 %{?__cxx:CXX="%{__cxx}"} \
251 --host=%{_target_platform} \
252 --build=%{_target_platform} \
253 --prefix=%{_prefix} \
254 --exec-prefix=%{_exec_prefix} \
255 --bindir=%{_bindir} \
256 --sbindir=%{_sbindir} \
257 --sysconfdir=%{_sysconfdir} \
258 --datadir=%{_datadir} \
259 --includedir=%{_includedir} \
260 --libdir=%{_libdir} \
261 --libexecdir=%{_libexecdir} \
262 --localstatedir=%{_localstatedir} \
263 --sharedstatedir=%{_sharedstatedir} \
264 --mandir=%{_mandir} \
265 --infodir=%{_infodir} \
266 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
267 %{dependencytracking} \
268 %{?configure_cache:--cache-file=%{configure_cache_file}} \
269}
270
271# overload to insert debuginfo package
272%prep \
273%if 0%{?_enable_debug_packages}\
274%{debug_package}\
275%endif\
276%%prep\
277%{nil}
278
279# Location of autoconf macros
280%_aclocaldir %{expand:%%global _aclocaldir %(aclocal --print-ac-dir || echo ERROR)}%_aclocaldir
281
282# Location of omf files
283%_omf_dest_dir %{expand:%%global _omf_dest_dir %(scrollkeeper-config --omfdir || echo ERROR)}%_omf_dest_dir
284
285# Location of pkgconfig files
286%_pkgconfigdir /usr/%{_lib}/pkgconfig
287# noarch pkgconfig files
288%_npkgconfigdir /usr/share/pkgconfig
289
290# Location of desktop files
291%_desktopdir /usr/share/applications
292%_applnkdir ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
293
294# Location of pixmaps for applnk/desktop files
295%_pixmapsdir /usr/share/pixmaps
296
297# Location of themable icons for applnk/desktop files
298%_iconsdir /usr/share/icons
299
300# Location of fonts directories
301%_fontsdir /usr/share/fonts
302
303# Location of Gtk and associated libraries documentation
304%_gtkdocdir %{_defaultdocdir}/gtk-doc/html
305
306# Location of KDE documentation
307%_kdedocdir %{_defaultdocdir}/kde/HTML
308
309# unsermake script
310%__unsermake /usr/share/unsermake/unsermake
311
312# Current date
313%date %(LC_ALL=C date +"%a %b %d %Y")
314
315# Example files, programs, scripts...
316%_examplesdir /usr/src/examples
317
318# Alternative kernel type/version
319%_alt_kernel %{nil}%{?alt_kernel:-%{?alt_kernel}}
320
321# The directory holding Linux kernel sources
322%_kernelsrcdir /usr/src/linux%{_alt_kernel}
323
324# If non-empty "debug" macro defined, add "dbg" suffix to release number
325%_rpmfilename %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
326
327
328%releq_kernel %{expand:%%global releq_kernel %(R=$(LC_ALL=C rpm -q --qf '%{N} = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel
329%releq_kernel_up %{expand:%%global releq_kernel_up %(R=$(LC_ALL=C rpm -q --qf '%{N}-up = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_up
330%releq_kernel_smp() %{expand:%%global releq_kernel_smp %(R=$(LC_ALL=C rpm -q --qf '%{N}-smp = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_smp
331%requires_releq_kernel(s:) Requires%{-s:(%{-s*})}: %releq_kernel
332%requires_releq_kernel_up(s:) Requires%{-s:(%{-s*})}: %releq_kernel_up
333%requires_releq_kernel_smp(s:) Requires%{-s:(%{-s*})}: %releq_kernel_smp
334
335# Requires name = version-release
336%requires_releq() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_eq_to -r %1 %1}}}
337# Requires: name = version
338%requires_eq() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_eq_to %1 %1}}}
339# Requires: name = version (version based on querying package %2)
340%requires_eq_to(r) %{!?2:ERROR}%{?3:ERROR}%{?2:%{!?3:%(if ! LC_ALL=C rpm -q --qf 'Requires: %1 = %|E?{%{E}:}|%{V}%{?-r:-%{R}}\\n' %2 | grep '^Requires:'; then echo "BuildRequires: %2"; fi)}}
341
342%apache_modules_api %{expand:%%global apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)}%apache_modules_api
343
344# kernel version-release handling
345%__kernel_ver %{expand:%%global __kernel_ver %( \\
346 Z=$(awk -F'"' '/UTS_RELEASE/{print $2}' %{_kernelsrcdir}/include/linux/{version,utsrelease}.h 2>/dev/null); \\
347 Z=${Z:-$(awk -F' = ' '/^VERSION/{v=$2} /^PATCHLEVEL/{p=$2} /^SUBLEVEL/{s=$2} /^EXTRAVERSION/{e=$2} END {printf("%d.%d.%d%s", v, p, s, e)}' %{_kernelsrcdir}/Makefile 2>/dev/null)}; \\
348 echo ${Z:-ERROR}; \\
349)}%__kernel_ver
350
351%__kernel_rel %{expand:%%global __kernel_rel %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rel
352%__kernel_rpmvr %{expand:%%global __kernel_rpmvr %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{V}-%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rpmvr
353%_kernel_ver %{expand:%%global _kernel_ver %{__kernel_ver}%{?with_dist_kernel:%(echo %{__kernel_ver} | grep -q -e - || echo -%{__kernel_rel})}}%_kernel_ver
354%_kernel_ver_str %{expand:%%global _kernel_ver_str %(echo %{!?_without_dist_kernel:%{__kernel_rpmvr}}%{?_without_dist_kernel:%{__kernel_ver}} | sed -e 's/-/_/g')}%_kernel_ver_str
355
356# `uname -r` to be used in @release field
357%_kernel_vermagic %{expand:%%global _kernel_vermagic %(echo %{_kernel_ver} | sed -e 's/-/_/g')}%_kernel_vermagic
358
359# sgml macros
360%xmlcat_add() /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
361%xmlcat_del() /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
362%xmlcat_add_rewrite /usr/bin/xmlcatalog --noout --add rewriteSystem
363%xmlcat_create() /usr/bin/xmlcatalog --noout --create %1 ;
364%sgmlcat_add() /usr/bin/install-catalog --add %1 %2 > /dev/null ;
365%sgmlcat_del() /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
366%docbook_sgmlcat_fix() { for l in \
367'' \
368' -- default decl --' \
369'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
370' -- hacks for opensp --' \
371'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
372'SYSTEM "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
373'' \
374; do echo $l; done >> %1 \
375}
376
377# vim - "
378
379# minimum file size needed for compressed documents.
380# just smaller files than this get larger when compressed.
381# some stats:
382# - 0 byte file compressed was 25 bytes .gz
383# - 39 byte file was compressed as 57
384# - with test/test.spec@man 158 byte file was compressed also 158
385%_min_compress_bytes 159
386
387#-----------------------------------------------------------------
388# find and gzip all files in %{_mandir} and %{infodir}
389#
390# Requires: xargs, find
391#
392#%no_install_post_compress_docs 1
393%__spec_install_post_compress_docs { \
394%{!?no_install_post_compress_docs:__spec_install_post_compress_docs() { \
395 for i in /usr/share/man /usr/X11R6/man; do \
396 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
397 echo "Compress man pages: $i"; \
398 find "$RPM_BUILD_ROOT$i" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
399 find "$RPM_BUILD_ROOT$i" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
400 find $RPM_BUILD_ROOT$i -type l | while read a; do \
401 m=$(readlink $a); \
402 rm -f $a; \
403 echo .so ${m##*/} > $a; \
404 echo >&2 "Converted ${a#$RPM_BUILD_ROOT} from symlink to man link: ${m##*/}"; \
405 done; \
406 find "$RPM_BUILD_ROOT$i" -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
407 fi; \
408 done; \
409 if [ -d "$RPM_BUILD_ROOT%{_infodir}" ]; then \
410 echo "Compress info pages: %{_infodir}"; \
411 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
412 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
413 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.info*' -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
414 fi; \
415}; __spec_install_post_compress_docs } }
416
417#-----------------------------------------------------------------
418# Strip executable binaries and shared object files
419#
420# Requires: find, awk, strip, cut, xargs
421#
422# Special macros which affect this process:
423#%no_install_post_strip 1 # disable stripping at all
424#%_noautostrip regexp # exclude files matching (anchored!) regex from stripping
425#%_autostripall regexp # strip files matching (anchored!) regex using plain strip
426#%_autostripunneeded regexp # strip files matching (anchored!) regex using strip --strip-unneeded
427#%_autostripdebug regexp # strip files matching (anchored!) regex using strip --strip-debug
428#
429%__spec_install_post_strip {%{!?debug: \
430%{!?no_install_post_strip:__spec_install_post_strip() { \
431if [ -d "$RPM_BUILD_ROOT" ]; then \
432 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
433 modulelist=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
434 if [ "$modulelist" ]; then \
435 modulecount=$(echo "$modulelist" | wc -l); \
436 printf "Stripping %d kernel modules..." $modulecount; \
437 echo "$modulelist" | xargs -l512 chmod u+w; \
438 echo "$modulelist" | xargs -l512 %{__strip} --strip-unneeded --remove-section=.comment --remove-section=.note.GNU-stack; \
439 echo "DONE"; \
440 fi; \
441 fi; \
442 filelist=$(find $RPM_BUILD_ROOT -type f ! -regex ".*/usr/lib[0-9]*/debug/.*\.debug" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautostrip:! -regex "%{_noautostrip}"} %{?_autostripall:! -regex "%{_autostripall}"} %{?_autostripunneeded:! -regex "%{_autostripunneeded}"} %{?_autostripdebug:! -regex "%{_autostripdebug}"}); \
443 if [ -n "$filelist" ]; then \
444 filetypes=`echo "$filelist" | xargs -r -d'\\n' file`; \
445 elfexelist=`echo "$filetypes" | awk -F: '/ELF.*executable/ {print $1}'`; \
446 elfsharedlist=`echo "$filetypes" | awk -F: '/LF.*shared object/ {print $1}'`; \
447 archiveslist=`echo "$filetypes" | awk -F: '/current ar archive/ {print $1}'`; \
448 if [ -n "$elfexelist" ]; then \
449 printf "Stripping %d ELF executables..." $(echo "$elfexelist" | wc -l); \
450 chmod u+w $elfexelist; \
451 %{__strip} --remove-section=.note --remove-section=.comment $elfexelist; \
452 echo "DONE"; \
453 fi; \
454 if [ -n "$elfsharedlist" ]; then \
455 printf "Stripping %d ELF shared libraries..." $(echo "$elfsharedlist" | wc -l); \
456 chmod u+w $elfsharedlist; \
457 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $elfsharedlist; \
458 echo "DONE"; \
459 fi; \
460 if [ -n "$archiveslist" ]; then \
461 printf "Stripping %d ar archives..." $(echo "$archiveslist" | wc -l); \
462 chmod u+w $archiveslist; \
463 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $archiveslist; \
464 echo "DONE"; \
465 fi; \
466 fi; \
467 filelist_all=%{?_autostripall:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripall}")}; \
468 filelist_unneeded=%{?_autostripunneeded:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripunneeded}")}; \
469 filelist_debug=%{?_autostripdebug:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripdebug}")}; \
470 if [ -n "$filelist_all" ]; then \
471 printf "Stripping everything from %d additional files..." $(echo "$filelist_all" | wc -l); \
472 chmod u+w $filelist_all; \
473 %{__strip} --remove-section=.note --remove-section=.comment $filelist_all; \
474 echo "DONE"; \
475 fi; \
476 if [ -n "$filelist_unneeded" ]; then \
477 printf "Stripping unneeded from %d additional files..." $(echo "$filelist_unneeded" | wc -l); \
478 chmod u+w $filelist_unneeded; \
479 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $filelist_unneeded; \
480 echo "DONE"; \
481 fi; \
482 if [ -n "$filelist_debug" ]; then \
483 printf "Stripping debuginfo from %d additional files..." $(echo "$filelist_debug" | wc -l); \
484 chmod u+w $filelist_debug; \
485 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $filelist_debug; \
486 echo "DONE"; \
487 fi; \
488fi; }; __spec_install_post_strip } } }
489
490#-----------------------------------------------------------------
491# remove all RPATH from executable binaries and shared object files
492#
493# Requires: find, awk, cut, xargs, chrpath, uname
494#
495# Special macros which affect this process
496#%no_install_post_chrpath 1 # disable chrpath at all
497#%_noautochrpath regex # exclude files matching (anchored!) regex from chrpath
498#
499%__spec_install_post_chrpath {%{!?debug: \
500%{!?no_install_post_chrpath: __spec_install_post_chrpath() { \
501if [ -d "$RPM_BUILD_ROOT" ]; then \
502 files=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautochrpath:! -regex "%{_noautochrpath}"}`; \
503 if [ -n "$files" ]; then \
504 objs=`echo "$files" | xargs -r -d'\\n' file | awk -F: '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}'`; \
505 fi; \
506 if [ -n "$objs" ]; then \
507 printf "Remove RPATH from %d executable binaries and shared object files.\n" $(echo "$objs" | wc -l); \
508 echo "$objs" | \
509 while read file; do \
510 rpath= ; \
511 chmod u+w "$file"; \
512 for dir in $(chrpath -l "$file" | awk '/RPATH=/ { gsub(/.*RPATH=/,""); gsub(/:/," "); print $0 }'); do \
513 case $dir in \
514 '$ORIGIN' ) \
515 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
516 else rpath="$rpath:$dir" ; fi ; \
517 continue ; \
518 ;; \
519 esac ; \
520 newdir=$(readlink -m "$dir"); \
521 [ ${#newdir} -le ${#dir} ] && dir=$newdir; \
522 case $dir in \
523 /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
524 echo "remove-rpath: $dir in $file"; \
525 ;; \
526 * ) \
527 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
528 else rpath="$rpath:$dir" ; fi ; \
529 ;; \
530 esac ; \
531 done ; \
532 if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
533 else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
534 done; \
535 fi; \
536fi; }; __spec_install_post_chrpath } } }
537
538#-----------------------------------------------------------------
539# Find all shared object files with unresolved symbols. Warn
540# and terminate if any found (termination can be turned off by define).
541#%no_install_post_check_so 1
542%__spec_install_post_check_so { \
543 __spec_install_post_check_so() { \
544 fail=0; \
545 printf "Searching for shared objects with unresolved symbols..."; \
546 for f in $(find $RPM_BUILD_ROOT -type f -name '*.so.*' -print); do \
547 LC_ALL=C objdump -T $f 2> /dev/null | LC_ALL=C awk -v "file=$f" 'BEGIN { found=0; skip["program_name"]=1; symbols = "" } /^[0-9a-z]+ +D +\*UND\*/ { if ($NF in skip) { next; }; found = 1; symbols = symbols "\n\t" $NF } END { if (found) { print "\nUnresolved symbols found in: " file symbols; exit(1); } } ' || fail=1 ; \
548 done ; \
549 echo " DONE"; \
550 %{!?no_install_post_check_so:[ $fail -eq 1 ] && : || :;} \
551}; __spec_install_post_check_so }}
552
553#-----------------------------------------------------------------
554# Find and gzip all kernel modules
555#
556# Requires: find
557#
558#%no_install_post_compress_modules 1
559%__spec_install_post_compress_modules { \
560%{!?no_install_post_compress_modules: __spec_install_post_compress_modules() { \
561 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
562 q=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
563 if [ "$q" ]; then \
564 printf "Compress %d kernel modules..." $(echo "$q" | wc -l); \
565 echo "$q" | xargs -r %{__gzip} -9nf; \
566 echo "DONE"; \
567 find $RPM_BUILD_ROOT/lib/modules -name '*o' -type l -printf "%p %l\n" | \
568 while read a b; do ln -sf $b.gz $a.gz; rm -f $a; done; \
569 fi; \
570 fi; \
571}; __spec_install_post_compress_modules } }
572
573# Remove common Perl files we don't package
574%__spec_install_post_perl_clean {\
575%{!?no_install_post_perl_clean: \
576%{?pdir:rm -f $RPM_BUILD_ROOT{%{perl_archlib}/perllocal.pod,%{perl_vendorarch}/auto/%{pdir}%{?pnam:/%(echo %{pnam} | tr - /)}/.packlist}} \
577} }
578
579#-----------------------------------------------------------------
580# Update GConf2 schemas
581#
582# Requires: GConf2
583#
584%gconf_schema_install() \
585 umask 022; \
586 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
587 /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null; \
588%{nil}
589
590%gconf_schema_uninstall() \
591if [ $1 = 0 -a -x /usr/bin/gconftool-2 ]; then \
592 umask 022; \
593 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
594 /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
595fi; \
596%{nil}
597
598#-----------------------------------------------------------------
599# Update desktop MIME database
600# requires: desktop-file-utils
601%update_desktop_database() {{ \
602 umask 022; \
603 /usr/bin/update-desktop-database -q; \
604};} \
605%{nil}
606
607%update_desktop_database_post %update_desktop_database
608
609%update_desktop_database_postun() {{ \
610if [ "$1" = "0" ]; then \
611 %update_desktop_database \
612fi; \
613};} \
614%{nil}
615
616#-----------------------------------------------------------------
617# Update shared MIME info database
618# requires: shared-mime-info
619#
620%update_mime_database() {{ \
621 umask 022; \
622 /usr/bin/update-mime-database %{_datadir}/mime; \
623};} \
624%{nil}
625
626#-----------------------------------------------------------------
627# Update icon cache
628# requires: gtk+
629#
630%update_icon_cache() {{ \
631 umask 022; \
632 /usr/bin/gtk-update-icon-cache -qf %{_datadir}/icons/%1; \
633};} \
634%{nil}
635
636#-----------------------------------------------------------------
637# Update scrollkeeper database
638# requires: scrollkeeper
639#
640%scrollkeeper_update_post() \
641 /usr/bin/scrollkeeper-update -q; \
642%{nil}
643
644%scrollkeeper_update_postun() \
645if [ "$1" = "0" ]; then \
646 /usr/bin/scrollkeeper-update -q; \
647fi; \
648%{nil}
649
650#-----------------------------------------------------------------
651# post %install sequence:
652# - autodeps exceptions
653# - compress all man and info pages,
654# - strip all ELF executables and ELF shared objects if not %debug.
655# - compress kernel modules if any
656
657###################################################################
658# Requires/Provides automation
659# exceptions system by Jacek Konieczny <jajcus@pld-linux.org>
660#
661%__noautoreqfiles %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
662%__noautoprovfiles %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
663%__noautoreq %(sed -e s'/#.*//' /etc/rpm/noautoreq)%{?_noautoreq: %{_noautoreq}}
664%__noautoreqdep %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
665%__noautoprov %(sed -e s'/#.*//' /etc/rpm/noautoprov)%{?_noautoprov: %{_noautoprov}}
666
667#%_noautocompressdoc %{nil}
668#
669%_missing_doc_files_terminate_build 1%{nil}
670%_unpackaged_files_terminate_build %{nil}
671# (X)emacs support
672%___emacs_lispdir_helper -batch -q -eval '(while load-path (princ (concat (car load-path) "\\n")) (setq load-path (cdr load-path)))' 2> /dev/null|sed -n '/\\(.*\\/x\\?emacs\\/site-lisp\\)\\/\\?$/{s,,\\1,p;q;}'
673%_emacs_lispdir %{expand:%%global _emacs_lispdir %(Z=$(emacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_emacs_lispdir
674%_xemacs_lispdir %{expand:%%global _xemacs_lispdir %(Z=$(xemacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_xemacs_lispdir
675
676%__php_provides %{nil}
677%__php_requires %{nil}
678%__perl_provides %{nil}
679%__perl_requires %{nil}
680%__mono_provides %{nil}
681%__mono_requires %{nil}
682
683# Perl specific macro definitions.
684%perl_privlib %{expand:%%global perl_privlib %(eval $(%{__perl} -V:installprivlib 2>/dev/null); echo ${installprivlib:-ERROR})}%perl_privlib
685%perl_archlib %{expand:%%global perl_archlib %(eval $(%{__perl} -V:installarchlib 2>/dev/null); echo ${installarchlib:-ERROR})}%perl_archlib
686%perl_vendorlib %{expand:%%global perl_vendorlib %(eval $(%{__perl} -V:installvendorlib 2>/dev/null); echo ${installvendorlib:-ERROR})}%perl_vendorlib
687%perl_vendorarch %{expand:%%global perl_vendorarch %(eval $(%{__perl} -V:installvendorarch 2>/dev/null); echo ${installvendorarch:-ERROR})}%perl_vendorarch
688%perl_sitelib %{expand:%%global perl_sitelib %(eval $(%{__perl} -V:installsitelib 2>/dev/null); echo ${installsitelib:-ERROR})}%perl_sitelib
689%perl_sitearch %{expand:%%global perl_sitearch %(eval $(%{__perl} -V:installsitearch 2>/dev/null); echo ${installsitearch:-ERROR})}%perl_sitearch
690
691# Ruby
692%__ruby /usr/bin/ruby
693%ruby_archdir %{expand:%%global ruby_archdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["archdir"]' 2>/dev/null || echo ERROR)}%ruby_archdir
694%ruby_ridir %{expand:%%global ruby_ridir %(%{__ruby} -r rbconfig -e 'include Config; print File.join(CONFIG["datadir"], "ri", CONFIG["ruby_version"], "system")' 2>/dev/null || echo ERROR)}%ruby_ridir
695%ruby_rubylibdir %{expand:%%global ruby_rubylibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["rubylibdir"]' 2>/dev/null || echo ERROR)}%ruby_rubylibdir
696%ruby_vendorarchdir %{expand:%%global ruby_vendorarchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorarchdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorarchdir
697%ruby_vendorlibdir %{expand:%%global ruby_vendorlibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorlibdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorlibdir
698%ruby_sitearchdir %{expand:%%global ruby_sitearchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitearchdir"]' 2>/dev/null || echo ERROR)}%ruby_sitearchdir
699%ruby_sitelibdir %{expand:%%global ruby_sitelibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitelibdir"]' 2>/dev/null || echo ERROR)}%ruby_sitelibdir
700%ruby_rdocdir /usr/share/rdoc
701%ruby_version %{expand:%%global ruby_version %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["ruby_version"]' 2>/dev/null || echo ERROR)}%ruby_version
702%ruby_ver_requires_eq Requires: ruby(ver) = %ruby_version
703%ruby_mod_ver_requires_eq Requires: ruby-modules(ver) = %ruby_version
704
705%php_pear_dir /usr/share/pear
706%php_data_dir /usr/share/php
707%php_extensiondir %{expand:%%global php_extensiondir %(php-config --extension-dir 2>/dev/null || echo ERROR)}%php_extensiondir
708%php_sysconfdir %{expand:%%global php_sysconfdir %(php-config --sysconfdir 2>/dev/null || echo ERROR)}%php_sysconfdir
709%php_includedir %{expand:%%global php_includedir %(php-config --include-dir 2>/dev/null || echo ERROR)}%php_includedir
710
711# extract php/zend api versions
712%php_major_version %{expand:%%global php_major_version %(awk '/#define PHP_MAJOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)}%php_major_version
713%php_api_version %{expand:%%global php_api_version %(awk '/#define PHP_API_VERSION/{print $3}' %{php_includedir}/main/php.h 2>/dev/null || echo ERROR)}%php_api_version
714%php_pdo_api_version %{expand:%%global php_pdo_api_version %(awk '/#define PDO_DRIVER_API/{print $3}' %{php_includedir}/ext/pdo/php_pdo_driver.h 2>/dev/null || echo ERROR)}%php_pdo_api_version
715%php_debug %{expand:%%global php_debug %(awk '/#define ZEND_DEBUG/{print $3}' %{php_includedir}/main/php_config.h 2>/dev/null || echo ERROR)}%php_debug
716%zend_module_api %{expand:%%global zend_module_api %(awk '/#define ZEND_MODULE_API_NO/{print $3}' %{php_includedir}/Zend/zend_modules.h 2>/dev/null || echo ERROR)}%zend_module_api
717%zend_extension_api %{expand:%%global zend_extension_api %(awk '/#define ZEND_EXTENSION_API_NO/{print $3}' %{php_includedir}/Zend/zend_extensions.h 2>/dev/null || echo ERROR)}%zend_extension_api
718%zend_zts %{expand:%%global zend_zts %(Z=$(grep -sc '^#define ZTS 1' %{php_includedir}/main/php_config.h); echo ${Z:-ERROR})}%zend_zts
719
720# helper macro
721%__php_api_requires(v:) Requires: php%{-v*}(%{expand:%1}) = %{expand:%{%{!?2:%{1}}%{?2}}}
722
723# macros for public use
724# for php extensions (php-pecl)
725%requires_php_extension %{__php_api_requires modules_api php_api_version} \
726%{__php_api_requires zend_module_api} \
727%{__php_api_requires -v %php_major_version debug php_debug} \
728%{__php_api_requires -v %php_major_version thread-safety zend_zts}
729
730# for zend extensions
731%requires_zend_extension %{__php_api_requires zend_module_api} \
732%{__php_api_requires zend_extension_api} \
733%{__php_api_requires -v %php_major_version debug php_debug} \
734%{__php_api_requires -v %php_major_version thread-safety zend_zts}
735
736# for php pdo modules (php-pecl-PDO_*)
737%requires_php_pdo_module %{__php_api_requires PDO_API php_pdo_api_version}
738
739# for using PHP post scripts. for PHP >= 5.0
740%php_webserver_restart \
741[ ! -f /etc/apache/conf.d/??_mod_php.conf ] || %service -q apache restart \
742[ ! -f /etc/httpd/conf.d/??_mod_php.conf ] || %service -q httpd restart \
743if [ -x /etc/rc.d/init.d/php-fcgi ]; then \
744 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
745 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php.fcgi* ]]; then \
746 %service -q php-fcgi restart \
747 fi \
748fi \
749if [ -x /etc/rc.d/init.d/php-fpm ]; then \
750 %service -q php-fpm restart \
751fi \
752%{nil}
753
754# for using php post scripts. for PHP >= 4.0 && PHP < 5.0
755%php4_webserver_restart \
756[ ! -f /etc/apache/conf.d/??_mod_php4.conf ] || %service -q apache restart \
757[ ! -f /etc/httpd/conf.d/??_mod_php4.conf ] || %service -q httpd restart \
758if [ -x /etc/rc.d/init.d/php-fcgi ]; then \
759 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
760 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php4.fcgi* ]]; then \
761 %service -q php-fcgi restart \
762 fi \
763fi \
764%{nil}
765
766# X.org helper macros
767%__xorg_abi_requires_ge() Requires: xorg-xserver-server(%{expand:%1}-abi) >= %{expand:%{%2}}
768%__xorg_abi_requires_lt() Requires: xorg-xserver-server(%{expand:%1}-abi) < %(awk -vv=%{expand:%{%2}} 'BEGIN{split(v, a, "."); printf("%s.0", a[1] + 1); exit}')
769
770%xorg_xserver_ansic_abi %{expand:%%global xorg_xserver_ansic_abi %(awk '/#define ABI_ANSIC_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_ansic_abi
771%xorg_xserver_extension_abi %{expand:%%global xorg_xserver_extension_abi %(awk '/#define ABI_EXTENSION_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_extension_abi
772%xorg_xserver_font_abi %{expand:%%global xorg_xserver_font_abi %(awk '/#define ABI_FONT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null | echo ERROR)}%xorg_xserver_font_abi
773%xorg_xserver_videodrv_abi %{expand:%%global xorg_xserver_videodrv_abi %(awk '/#define ABI_VIDEODRV_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_videodrv_abi
774%xorg_xserver_xinput_abi %{expand:%%global xorg_xserver_xinput_abi %(awk '/#define ABI_XINPUT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_xinput_abi
775
776%requires_xorg_xserver_extension \
777%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
778%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
779%{__xorg_abi_requires_ge extension xorg_xserver_extension_abi} \
780%{__xorg_abi_requires_lt extension xorg_xserver_extension_abi} \
781%{nil}
782
783%requires_xorg_xserver_xinput \
784%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
785%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
786%{__xorg_abi_requires_ge xinput xorg_xserver_xinput_abi} \
787%{__xorg_abi_requires_lt xinput xorg_xserver_xinput_abi} \
788%{nil}
789
790%requires_xorg_xserver_font \
791%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
792%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
793%{__xorg_abi_requires_ge font xorg_xserver_font_abi} \
794%{__xorg_abi_requires_lt font xorg_xserver_font_abi} \
795%{nil}
796
797%requires_xorg_xserver_videodrv \
798%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
799%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
800%{__xorg_abi_requires_ge videodrv xorg_xserver_videodrv_abi} \
801%{__xorg_abi_requires_lt videodrv xorg_xserver_videodrv_abi} \
802%{nil}
803
804# TCL specific macro definitions.
805# TODO: when th tcl is fixed use tclsh to get version: %(echo 'puts $tcl_version' | tclsh)
806%tcl_version %{expand:%%global tcl_version %(v=$(rpm -q --qf %{V} tcl | cut -d. -f1,2); echo ${v:-ERROR})}%tcl_version
807%tcl_sitearch %{_libdir}/tcl%{tcl_version}
808%tcl_sitelib %{_datadir}/tcl%{tcl_version}
809
810# Python specific macro definitions.
811# python main version
812%py_ver %{expand:%%global py_ver %(%{__python} -c "import sys; print sys.version[:3]" 2>/dev/null || echo ERROR)}%py_ver
813
814# directories
815%py_prefix %{expand:%%global py_prefix %(%{__python} -c "import sys; print sys.prefix" 2>/dev/null || echo ERROR)}%py_prefix
816%py_libdir %{py_prefix}/%{_lib}/python%{py_ver}
817%py_scriptdir %{py_prefix}/share/python%{py_ver}
818%py_incdir /usr/include/python%{py_ver}
819%py_sitedir %{py_libdir}/site-packages
820%py_sitescriptdir %{py_scriptdir}/site-packages
821%py_dyndir %{py_libdir}/lib-dynload
822
823# pure python modules compilation
824%py_comp python -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
825
826%py_ocomp python -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
827
828# Software written in Python language require Python with main version
829%pyrequires_eq() Requires: %1
830
831# Python 3.x
832# python main version
833%__python3 python3.0
834%py3_ver %{expand:%%global py3_ver %(%{__python3} -c "import sys; print(sys.version[:3])" 2>/dev/null || echo ERROR)}%py3_ver
835
836# directories
837%py3_prefix %{expand:%%global py3_prefix %(%{__python3} -c "import sys; print(sys.prefix)" 2>/dev/null || echo ERROR)}%py3_prefix
838%py3_libdir %{py3_prefix}/%{_lib}/python%{py3_ver}
839%py3_scriptdir %{py3_prefix}/share/python%{py3_ver}
840%py3_incdir /usr/include/python%{py3_ver}
841%py3_sitedir %{py3_libdir}/site-packages
842%py3_sitescriptdir %{py3_scriptdir}/site-packages
843%py3_dyndir %{py3_libdir}/lib-dynload
844
845# pure python modules compilation
846%py3_comp %{__python3} -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
847
848%py3_ocomp %{__python3} -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
849
850# Hardlink binary identical .pyc and .pyo files
851%__spec_install_post_py_hardlink {\
852%{!?no_install_post_py_hardlink: __spec_install_post_py_hardlink() { \
853local a b c=0 t=0; \
854if [ -d "$RPM_BUILD_ROOT" ]; then \
855 find "$RPM_BUILD_ROOT" -name '*.pyc' > __rpm_pyc; \
856 while read a; do \
857 b="${a%.pyc}.pyo"; \
858 if cmp -s "$a" "$b"; then \
859 ln -f "$a" "$b"; \
860 c=$((c + 1)); \
861 fi; \
862 t=$((t + 1)); \
863 done < __rpm_pyc; \
864 [ $t -gt 0 ] && printf "Hardlink Python files: %d/%d files hardlinked\n" $c $t; \
865 rm -f __rpm_pyc; \
866fi; \
867}; __spec_install_post_py_hardlink } }
868
869# remove python sources, so that check-files won't complain
870%py_postclean() \
871for d in %{py_sitescriptdir} %{py_sitedir} %*; do \
872 [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
873done \
874%{nil}
875
876%py3_postclean() \
877for d in %{py3_sitescriptdir} %{py3_sitedir} %*; do \
878 [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
879done \
880%{nil}
881
882# depmod macro
883%depmod() { \
884umask 022; \
885if [ -e /boot/System.map-%1 ]; then \
886 /sbin/depmod -a -F /boot/System.map-%1 %1; \
887else \
888 if [ -e /boot/System.map ]; then \
889 /sbin/depmod -a -F /boot/System.map %1; \
890 else \
891 /sbin/depmod -a %1; \
892 fi \
893fi; \
894}
895
896# XMMS specific macros
897%xmms_prefix %{expand:%%global xmms_prefix %(xmms-config --prefix 2>/dev/null || echo ERROR)}%xmms_prefix
898%xmms_exec_prefix %{expand:%%global xmms_exec_prefix %(xmms-config --exec-prefix 2>/dev/null || echo ERROR)}%xmms_exec_prefix
899%xmms_version %{expand:%%global xmms_version %(xmms-config --version 2>/dev/null || echo ERROR)}%xmms_version
900%xmms_datadir %{expand:%%global xmms_datadir %(xmms-config --data-dir 2>/dev/null || echo ERROR)}%xmms_datadir
901%xmms_plugindir %{expand:%%global xmms_plugindir %(xmms-config --plugin-dir 2>/dev/null || echo ERROR)}%xmms_plugindir
902%xmms_visualization_plugindir %{expand:%%global xmms_visualization_plugindir %(xmms-config --visualization-plugin-dir 2>/dev/null || echo ERROR)}%xmms_visualization_plugindir
903%xmms_input_plugindir %{expand:%%global xmms_input_plugindir %(xmms-config --input-plugin-dir 2>/dev/null || echo ERROR)}%xmms_input_plugindir
904%xmms_output_plugindir %{expand:%%global xmms_output_plugindir %(xmms-config --output-plugin-dir 2>/dev/null || echo ERROR)}%xmms_output_plugindir
905%xmms_effect_plugindir %{expand:%%global xmms_effect_plugindir %(xmms-config --effect-plugin-dir 2>/dev/null || echo ERROR)}%xmms_effect_plugindir
906%xmms_general_plugindir %{expand:%%global xmms_general_plugindir %(xmms-config --general-plugin-dir 2>/dev/null || echo ERROR)}%xmms_general_plugindir
907
908%_target_base_arch %{expand:%%global _target_base_arch %(echo %{_target_cpu} | sed 's/i.86/i386/;s/athlon/i386/;s/pentium./i386/;s/amd64/x86_64/;s/ia32e/x86_64/')}%_target_base_arch
909
910# user/group checking macros
911#
912# Usage:
913# %userremove myuser
914#
915%userremove /usr/lib/rpm/user_group.sh user del
916%groupremove /usr/lib/rpm/user_group.sh group del
917#
918# Usage:
919# if %usertestrm myuser; then
920# /usr/sbin/userdel -r myuser
921# Note:
922# use these macros only if you need to call userdel/groupdel with
923# a non-standard option or take an extra action; otherwise use the
924# %userremove/%groupremove macros
925#
926%usertestrm /usr/lib/rpm/user_group.sh user testrm
927%grouptestrm /usr/lib/rpm/user_group.sh group testrm
928# user group membership management macros
929#
930# Usage:
931# %addusertogroup [-q] myuser agroup
932#
933# -q if user or group don't exist, don't make big noise of it (MISSINGOK behaviour)
934#
935# Requirements:
936# BuildRequires: rpmbuild(macros) >= 1.515
937%addusertogroup(q) quiet=%{-q:1} /usr/lib/rpm/user_group.sh user addtogroup %*
938
939# banner support (useful in {pre,post}{,un} and triggers)
940#
941# Usage:
942# %banner name [-a] [-e] [-n] [-tn] <<EOF
943# the banner text, the banner text
944# the banner text, and following line
945#EOF
946# You can use any form of here-document, <<'EOF' <<-EOT will do.
947# NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
948#
949# -a - append to the banner
950# -e - send to stderr instead of stdout
951# -n - no show banner (overrides -t)
952# -t - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
953#
954# Tests:
955# (rpm -E '%banner -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m
956# rpm -E 'date | %banner -e banner' > m; sh -x m
957#
958%banner(aent:) ( \
959RPM_SCRIPTVERBOSITY=5 \
960[ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
961if [ -x /usr/bin/banner.sh ]; then \
962 CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
963else \
964 CMD="cat%{-e: >&2}" \
965fi \
966eval $CMD %{?2:%2}%{?3: %3}) \
967%{nil}
968
969# useradd/groupadd macros
970# Author: Elan Ruusamäe <glen@pld-linux.org>
971#
972# Usage:
973# %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
974# [-g initial_group] [-G group[,...]] login
975#
976# -u uid. REQUIRED
977# -g gid/group. REQUIRED
978# -s defaults to /bin/false
979# -d defaults to /usr/share/empty
980# -c No default
981# -r is accepted but ignored (it's always set)
982# -k skeleton dir. defaults to /usr/share/empty
983# rpm specific flags
984# -P package name. defaults to %{name}
985#
986%useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
987%{!-u:%{error:useradd: Required argument -u missing}} \
988%{!-g:%{error:useradd: Required argument -g missing}} \
989%{!?1:%{error:useradd: Required parameter login missing}} \
990if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
991 if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
992 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
993 exit 1 \
994 fi \
995else \
996 echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
997 /usr/sbin/useradd \\\
998 %{-m:-m -k %{-k*}%{!-k:/usr/share/empty}} \\\
999 -u %{-u*} \\\
1000 -r \\\
1001 -d %{-d*}%{!-d:/usr/share/empty} \\\
1002 -s %{-s*}%{!-s:/bin/false} \\\
1003 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
1004 -g %{-g*} \\\
1005 %{-M} \\\
1006 %{-G:-G %{-G*}} \\\
1007 %{expand:%{%{#}}} 1>&2 || exit $? \
1008 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i passwd || : \
1009fi;
1010
1011# Usage:
1012# %groupadd [-P package] [-g gid] group
1013#
1014# -g gid. REQUIRED
1015#
1016# Sample:
1017# %groupadd -P %{name}-base -g %{gid} %{name}
1018
1019%groupadd(g:P:rfo) \
1020%{!-g:%{error:groupadd: Required argument -g missing}} \
1021%{!?1:%{error:groupadd: Required parameter group missing}} \
1022if /usr/bin/getgid %{1} > /dev/null 2>&1; then \
1023 if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
1024 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
1025 exit 1 \
1026 fi \
1027else \
1028 echo "Adding group %{1} GID=%{-g*}." \
1029 /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 || exit $? \
1030 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i group || : \
1031fi;
1032
1033# webapp macros
1034# Author: Elan Ruusamäe <glen@pld-linux.org>
1035#
1036# The config is installed/removed inside trigger, this means that you can any
1037# time install apache1/apache/lighttpd package and the configuration file is
1038# updated. if you don't need the config for various reason for specific
1039# webserver, just remove the symlink from config directory using webapp
1040# program. the trigger will not recreate the symlink on upgrades. In other
1041# words the config is linked to webserver config directory on first install of
1042# PACKAGE or WEBSERVER.
1043#
1044# Add package's webserver config to webserver webapps dir.
1045# Usage:
1046# %webapp_register WEBSERVER WEBAPP
1047#
1048%webapp_register() \
1049%{?debug:set -x; echo "webapp_register: %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
1050if [ "$1" = "1" ] && [ "$2" = "1" ]; then\
1051 /usr/sbin/webapp register %1 %2\
1052fi\
1053# reload webserver if the config symlink is there and skip reload if webserver is upgraded\
1054if [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ] && [ "$2" -lt "2" ]; then\
1055 %{expand:%service -q %%1 reload}\
1056fi\
1057%{nil}
1058
1059# Remove package's config from webserver webapps dir.
1060# Usage:
1061# %webapp_register [-f] WEBSERVER WEBAPP
1062%webapp_unregister(f) \
1063%{?debug:set -x; echo "webapp_unregister: %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
1064# remove link if either of the packages are gone \
1065if [ -n "%{-f:1}" ] || [ "$1" = "0" ] || [ "$2" = "0" ] && [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ]; then \
1066 /usr/sbin/webapp unregister %1 %2\
1067 %{expand:%service -q %%1 reload}\
1068fi \
1069%{nil}
1070
1071# service macro.
1072# Author: Elan Ruusamäe <glen@pld-linux.org>
1073#
1074# calls usual service restart on package %post, but skips the restart if
1075# administrator has disabled automatic service restarts in either global
1076# /etc/sysconfig/rpm or per service /etc/sysconfig/SERVICE file.
1077#
1078# Usage:
1079# %service [-q] [-n] SERVICE ACTION ["SERVICE NICE DESCRIPTION"]
1080#
1081# -q be silent when service isn't started (for scriplets restaring other package's services)
1082# -n NOOP mode, do not actually restart service
1083#
1084# Requirements:
1085# BuildRequires: rpmbuild(macros) >= 1.268
1086# Requires: rc-scripts
1087# -n option:
1088# BuildRequires: rpmbuild(macros) >= 1.450
1089%service(qn) {{%(export noop=%{-n:1} quiet=%{-q:1}; /usr/lib/rpm/service_generator.sh %{*}) };}
1090
1091
1092# Java macros. based on jpackage macros.java
1093#
1094# Root directory where all Java VMs/SDK/JREs are installed.
1095%_jvmdir %{_libdir}/jvm
1096
1097# Root directory where all Java VMs/SDK/JREs expose their jars
1098%_jvmjardir %{_libdir}/jvm-exports
1099
1100# Root directory for all Java VM/SDK/JRE's private things.
1101%_jvmprivdir %{_libdir}/jvm-private
1102
1103# Root directory for all architecture dependent parts of Java VM/SDK/JRE's
1104%_jvmlibdir %{_libdir}/jvm
1105
1106# Root directory for all architecture independent parts of Java VM/SDK/JRE's
1107%_jvmdatadir %{_datadir}/jvm
1108
1109# Root directory for all configurations parts of Java VM/SDK/JRE's
1110%_jvmsysconfdir %{_sysconfdir}/jvm
1111
1112# Root directory for all common architecture dependent parts of Java VM/SDK/JRE's
1113%_jvmcommonlibdir %{_libdir}/jvm-common
1114
1115# Root directory for all common architecture independent parts of Java VM/SDK/JRE's
1116%_jvmcommondatadir %{_datadir}/jvm-common
1117
1118# Root directory for all common configurations parts of Java VM/SDK/JRE's
1119%_jvmcommonsysconfdir %{_sysconfdir}/jvm-common
1120
1121# Directory where arch-specific (JNI) version-independent jars are installed.
1122%_jnidir %{_libdir}/java
1123
1124%java_home %{expand:%%global java_home %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVA_HOME; . %{_javadir}-utils/java-functions; set_jvm; echo ${JAVA_HOME:-ERROR})}%java_home
1125
1126%ant JAVA_HOME=%{java_home} CLASSPATH=$CLASSPATH ant
1127%jar %{java_home}/bin/jar
1128%java %{expand:%%global java %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVACMD; . %{_javadir}-utils/java-functions; set_javacmd; echo $JAVACMD)}%java
1129%javac %{java_home}/bin/javac
1130%javadoc %{java_home}/bin/javadoc
1131
1132%add_jvm_extension JAVA_LIBDIR=%{buildroot}/%{_javadir} %{_bindir}/jvmjar -l
1133
1134%jpackage_script() \
1135install -d $RPM_BUILD_ROOT%{_bindir}\
1136cat > $RPM_BUILD_ROOT%{_bindir}/%5 << 'EOF' \
1137#!/bin/sh\
1138#\
1139# %{name} script\
1140# JPackage Project <http://www.jpackage.org/>\
1141\
1142# Source functions library\
1143. %{_javadir}-utils/java-functions\
1144\
1145# Source system prefs\
1146if [ -f %{_sysconfdir}/java/%{name}.conf ]; then\
1147 . %{_sysconfdir}/java/%{name}.conf\
1148fi\
1149\
1150# Source user prefs\
1151if [ -f $HOME/.%{name}rc ]; then\
1152 . $HOME/.%{name}rc\
1153fi\
1154\
1155# Configuration\
1156MAIN_CLASS=%1\
1157BASE_FLAGS=%2\
1158BASE_OPTIONS=%3\
1159BASE_JARS="%(echo %4 | tr ':' ' ')"\
1160\
1161# Set parameters\
1162set_jvm\
1163set_classpath $BASE_JARS\
1164set_flags $BASE_FLAGS\
1165set_options $BASE_OPTIONS\
1166\
1167# Let's start\
1168run "$@"\
1169EOF
1170
1171# jpackage 1.7
1172# Directory for maven depmaps
1173#
1174%_mavendepmapdir /etc/maven
1175%_mavendepmapfragdir /etc/maven/fragments
1176
1177#
1178# add_to_depmap adds an entry to the depmap. The arguments are:
1179#
1180# %1 the original groupid
1181# %2 the original artifact id
1182# %3 the version
1183# %4 the new groupid
1184# %5 the new artifactid
1185#
1186
1187%add_to_maven_depmap() \
1188install -dm 755 $RPM_BUILD_ROOT/%{_mavendepmapfragdir}\
1189cat >>$RPM_BUILD_ROOT/%{_mavendepmapfragdir}/%{name}<< EOF\
1190<dependency>\
1191 <maven>\
1192 <groupId>%1</groupId>\
1193 <artifactId>%2</artifactId>\
1194 <version>%3</version>\
1195 </maven>\
1196 <jpp>\
1197 <groupId>%4</groupId>\
1198 <artifactId>%5</artifactId>\
1199 <version>%3</version>\
1200 </jpp>\
1201</dependency>\
1202\
1203EOF\
1204%{nil}
1205
1206#==============================================================================
1207#
1208# update_maven_depmap updates the main maven depmap
1209#
1210%update_maven_depmap() \
1211echo -e "<dependencies>\\n" > %{_mavendepmapdir}/maven2-depmap.xml\
1212if [ -d %{_mavendepmapfragdir} ] && [ -n "`find %{_mavendepmapfragdir} -type f`" ]; then\
1213cat %{_mavendepmapfragdir}/* >> %{_mavendepmapdir}/maven2-depmap.xml\
1214fi\
1215echo -e "</dependencies>\\n" >> %{_mavendepmapdir}/maven2-depmap.xml
1216
1217
1218# PEAR install macros
1219# Author: Elan Ruusamäe <glen@pld-linux.org>
1220#
1221# Usage:
1222# %%pear_package_setup ...
1223#
1224# -a # - also unpack SOURCE#. for PEAR bootstrapping
1225# -n FMT - create builddir with FMT, instead of default %%{_pearname}-%%{version}
1226# -z - unpack pear package and let pear use package.xml (not tarball) for install. for PEAR bootstrapping
1227# -D - pass -D to %setup (so the build dir is not removed)
1228# -c - register channel from local channel.xml file
1229#
1230# unpack PEAR package to %%{_builddir}/FMT. package is extracted with already
1231# destination hierarchy. you should copy the tree to buildroot after
1232# patching/reorganizing with %%pear_package_install.
1233#
1234# additionally BUILDROOT is stripped from files and files are converted to UNIX
1235# line endings.
1236#
1237# the pear install process output is recorded to install.log, you should put it
1238# to %%doc for later debug or just for information.
1239#
1240# additionally additional-packages.txt is produced if it was detected that the
1241# package has optional dependencies. the file format is suitable of displaying
1242# in %%post of a package. you should put this file to %%doc. noautocompressdoc is
1243# automatically added for this file.
1244
1245
1246# records install.log and transforms PEAR names to PLD Linux rpm package names.
1247%__pear_install_log \
1248tee install.log \
1249# make post message of optional packages \
1250grep 'can optionally use' install.log | sed -e 's,package "pear/,package "php-pear-,g;s,^pear/,php-pear-,;s,^pear/,php-pear-,;s,^channel://.*/,,' > optional-packages.txt \
1251if [ -s optional-packages.txt ]; then \
1252 awk -F'"' '/use package/{print $2}' optional-packages.txt | sed -e "s,_,/,g;s,php-pear-, 'pear(,;s,$,.*)'," | tr -d '\\\n' > _noautoreq \
1253else \
1254 rm -f optional-packages.txt \
1255fi \
1256%{nil}
1257
1258# command invoking pear cli
1259%__pear /usr/bin/pear
1260
1261%pear_install(a:n:zD) \
1262%__pear \\\
1263 -c %{builddir}/pearrc \\\
1264 -d doc_dir=/docs \\\
1265 -d temp_dir=/tmp \\\
1266 -d php_dir=%{-c:%{builddir}/}%{php_pear_dir} \\\
1267 -d bin_dir=%{_bindir} \\\
1268 -d data_dir=%{php_pear_dir}/data \\\
1269 -d test_dir=%{php_pear_dir}/tests \\\
1270 install \\\
1271 --packagingroot=%{builddir} \\\
1272 --offline \\\
1273 --nodeps \\\
1274 %{-f:--force} \\\
1275 %{!-z:%{S:%{-a*}%{!-a:0}}}%{-z:$_P} > .install.log || { c=$?; cat .install.log; exit $c; }; \
1276 %{-c:cp -a %{builddir}/%{builddir}/%{php_pear_dir} %{builddir}/%(dirname %{php_pear_dir}); rm -rf %{builddir}/%{builddir}; } \
1277%{nil}
1278
1279# The main macro.
1280# using this macro will append optional-packages.txt to the nocompressdoc list
1281# as it's displayed to user after package install. and adding additional gzip
1282# dep is just waste ;)
1283%pear_package_setup(a:n:zDc:) \
1284%define srcdir %{-n*}%{!-n:%{_pearname}-%{version}} \
1285%define builddir %{_builddir}/%{srcdir} \
1286%setup -q -c -T %{-D:-D} -n %{srcdir} \
1287%{-z:tar zxf %{S:0}; %{-a:tar zxf %{S:%{-a*}}}} \
1288%{-z:_P=package2.xml; [ -f $_P ] || _P=package.xml; _N=%{srcdir}; mv $_P $_N; cd $_N} \
1289%{-c:%{__pear} -c pearrc config-set php_dir %{builddir}/%{php_pear_dir}; %__pear -c %{builddir}/pearrc channel-add %{-c*}} \
1290%pear_install \
1291%{-z:cd ..} \
1292cat %{-z:$_N/}.install.log | %__pear_install_log \
1293\
1294# undos sources \
1295find -type f -print0 | xargs -0 sed -i -e 's,\\r$,,' \
1296%{!?_noautocompressdoc:%global _noautocompressdoc %{nil}}%{expand:%%global _noautocompressdoc %{_noautocompressdoc} optional-packages.txt} \
1297%{!?_noautoprov:%global _noautoprov %{nil}}%{expand:%%global _noautoprov %{_noautoprov} 'pear(tests/.*)'} \
1298%{nil}
1299
1300# Copies exctracted PEAR package structure and PEAR registry to buildroot.
1301# Author: Elan Ruusamäe <glen@pld-linux.org>
1302%pear_package_install() \
1303cp -a ./%{php_pear_dir}/{.registry,*} $RPM_BUILD_ROOT%{php_pear_dir} \
1304find $RPM_BUILD_ROOT%{php_pear_dir} '(' -name '*~' -o -name '*.orig' ')' | xargs -r rm -v \
1305# help the developer out a little: \
1306if [ -f _noautoreq ]; then \
1307 echo "AutoReqdep detected:" \
1308 echo "_noautoreq $(cat _noautoreq)" \
1309fi \
1310%{nil}
1311
1312
1313# Register OpenLDAP schema.
1314# Author: Elan Ruusamäe <glen@pld-linux.org>
1315#
1316# Usage:
1317# %%openldap_schema_register [-d core,nis] %{schemadir}/horde.schema
1318#
1319# -d specify dependant schemas, separated by comma
1320#
1321%openldap_schema_register(d:) \
1322for schema in %*; do \
1323 if ! grep -q "$schema" /etc/openldap/slapd.conf; then \
1324 %{__sed} -i -e " \
1325 /^include.*local.schema/{ \
1326 iinclude\\t $schema\
1327 } \
1328 " /etc/openldap/slapd.conf \
1329 fi \
1330done \
1331# enable dependant schemas \
1332if [ "%{-d*}" ]; then \
1333 %{__sed} -i -e ' \
1334 /^#include.*\\(%(echo '%{-d*}' | %{__sed} -e 's/,/\\\\|/g')\\)\\.schema/{ \
1335 s/^#// \
1336 }' /etc/openldap/slapd.conf \
1337fi \
1338%{nil}
1339
1340# Unregister OpenLDAP schema.
1341# Author: Elan Ruusamäe <glen@pld-linux.org>
1342#
1343# Usage:
1344# %%openldap_schema_unregister %{schemadir}/horde.schema
1345#
1346%openldap_schema_unregister() \
1347for schema in %*; do \
1348 if grep -q "$schema" /etc/openldap/slapd.conf; then \
1349 %{__sed} -i -e " \
1350 /^include.*$(echo "$schema" | %{__sed} -e 's,/,\\\\/,g')/d \
1351 # for symmetry it would be nice if we disable enabled schemas in post, \
1352 # but we really can not do that, it would break something else. \
1353 " /etc/openldap/slapd.conf \
1354 fi \
1355done \
1356%{nil}
1357
1358%env_update [ ! -x /sbin/env-update ] || /sbin/env-update -u || :
1359
1360
1361# Build modules for kernels 2.6
1362# Author: Przemyslaw Iskra <sparky@pld-linux.org>
1363#
1364# Usage:
1365# %build_kernel_modules -m <modules> -C <directory>
1366#
1367# remember that proper Makefile is still required
1368# Options:
1369# -m <modules> (required) -- comma-separated list of modules to save,
1370# without .ko extension, may be placed in subdirectory
1371# -C <directory> -- change to <directory> before doing anything
1372# -p <arg>, -P <arg> -- arguments passeed to make scripts
1373# -c -- do not execute make clean
1374# <additional arguments> -- all additional arguments will be passed to
1375# make modules
1376#
1377# Additional patching supported via here document. Try:
1378# %build_kernel_modules -m module <<'EOF'
1379# your patch script here
1380# EOF
1381# Don't use it unless patching depends on config options.
1382
1383# Developer note: don't touch it unless you know how to handle '\'.
1384# - \ in script expands to nothing
1385# - \\\ in script expands to \
1386# - \\\ inside definition expands to nothing
1387# - \\\\\\\ inside definition expands to \
1388# - in last line \ has to touch arguments so arguments passing
1389# in new lines (using \) will be supported
1390
1391%build_kernel_modules(p:P:m:C:c) \
1392%{!?-m:%{error:%{0}: Required module name/list missing} exit 1} \
1393 \
1394%define Opts \\\\\\\
1395%if "%{_target_base_arch}" != "%{_arch}" \\\
1396 %if "%{_arch}" == "x86_64" && "%{_target_base_arch}" == "i386" \\\
1397 CC="%{kgcc}" ARCH=%{_target_base_arch} \\\
1398 %else \\\
1399 ARCH=%{_target_base_arch} CROSS_COMPILE=%{_target_cpu}-pld-linux- \\\
1400 %endif \\\
1401%else \\\
1402 CC="%{kgcc}" \\\
1403%endif \
1404%define MakeOpts HOSTCC="%{kgcc}" SYSSRC=%{_kernelsrcdir} SYSOUT=$PWD/o \\\\\\\
1405 O=$PWD/o %{?with_verbose:V=1} %{Opts} \
1406 \
1407%{?-C:cd %{-C*}} \
1408compile() { \
1409 local L="<" PATCH_SH; \
1410 [[ '%{*}' != *$L$L* ]] || PATCH_SH="set -x -e;$(cat)" \
1411 set -e -x \
1412 local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
1413 \
1414for cfg in ${cfgs:-dist}; do \
1415 [ -r "%{_kernelsrcdir}/config-$cfg" ] || exit 1 \
1416 \
1417 rm -rf o \
1418 install -d o/include/linux o/arch/powerpc/lib \
1419 ln -sf %{_kernelsrcdir}/config-$cfg o/.config \
1420 ln -sf %{_kernelsrcdir}/Module.symvers-$cfg o/Module.symvers \
1421 ln -sf %{_kernelsrcdir}/include/linux/autoconf-$cfg.h o/include/linux/autoconf.h \
1422 \
1423 set +x \
1424 [ -z "$PATCH_SH" ] || echo "$PATCH_SH" | %__spec_build_shell \
1425 set -x \
1426 \
1427 %if %{with dist_kernel} || %(test -f %{_kernelsrcdir}/scripts/bin2c ; echo $?) \
1428 %{__make} -j1 -C %{_kernelsrcdir} prepare scripts \\\
1429 %{-p*} %{-P*} \\\
1430 %{MakeOpts} \
1431 %else \
1432 install -d o/include/config \
1433 touch o/include/config/MARKER \
1434 ln -sf %{_kernelsrcdir}/include/config/auto-$cfg.conf o/include/config/auto.conf \
1435 ln -sf %{_kernelsrcdir}/scripts o/scripts \
1436 %endif \
1437 \
1438 %{!?-c:%{__make} -C %{_kernelsrcdir} clean \\\
1439 RCS_FIND_IGNORE="-name '*.ko' -o" \\\
1440 ${1+"$@"} \\\
1441 M=$PWD %{MakeOpts}} \
1442 \
1443 %{__make} -C %{_kernelsrcdir} modules \\\
1444 ${1+"$@"} \\\
1445 M=$PWD %{MakeOpts} \
1446 \
1447 for MODULE in {%{-m*},}; do \
1448 [ -z "${MODULE}" ] || mv ${MODULE}{,-$cfg}.ko \
1449 done \
1450done \
1451%{?-C:cd -} \
1452} \
1453compile %{*}\
1454%{nil}
1455
1456
1457# Install kernel modules built by %build_kernel_modules
1458# Author: Przemyslaw Iskra <sparky@pld-linux.org>
1459#
1460# Usage:
1461# %install_kernel_modules -m <modules> -d <directory>
1462#
1463# Options:
1464# -m <modules> (required) -- comma-separated list of modules to install,
1465# without .ko extension, may be placed in subdirectory
1466# -d <directory> (required) -- in what subdirectory modules should be
1467# installed (eg. misc, kernel/drivers/net)
1468# -s <suffix> -- suffix to use when installing modules, useful when module
1469# with same name exists in kernel already
1470# -n <file> -- name of modprobe config file to use (without .conf extension)
1471# for defining aliases, only useful with -s
1472
1473%install_kernel_modules(m:d:s:n:) \
1474%{!?-m:%{error:%{0}: Required module name (-m) missing}exit 1} \
1475%{!?-d:%{error:%{0}: Required module directory missing}exit 1} \
1476%{?-n:%{!?-s:%{error:%{0}: Modprobe .conf file requires module suffix}exit 1}} \
1477 \
1478%define KernelD $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver} \
1479%define ModprobeD $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.d/%{_kernel_ver} \
1480 \
1481__install_kernel_modules() { \
1482local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
1483 \
1484for MODULE in {%{-m*},}; do \
1485 [ -n "${MODULE}" ] || continue \
1486 for cfg in ${cfgs:-dist}; do \
1487 [ "$cfg" = smp ] && suf=smp || suf= \
1488 MNAME=${MODULE##*/} \
1489 install -D ${MODULE}-$cfg.ko \\\
1490 %{KernelD}$suf/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko \
1491 %{?-s:install -d %{ModprobeD}$suf \
1492 echo "alias ${MNAME} ${MNAME}-%{-s*}" \\\
1493 >> %{ModprobeD}$suf/%{-n*}.conf} \
1494 done \
1495done \
1496} \
1497__install_kernel_modules \
1498%{nil}
1499
1500# patchset macros
1501# Author: Elan Ruusamäe <glen@pld-linux.org>
1502#
1503# Usage:
1504# %patchset_source -f <seq(1) format> <start> [<end>]
1505# %patchset_patch <start> [<end>]
1506#
1507# If <end> is omited, it is assumed to be <start>.
1508#
1509# For example in preamble:
1510# %patchset_source -f ftp://ftp.vim.org/pub/editors/vim/patches/7.0/7.0.%03g 33 44
1511# and in %prep:
1512# %patchset_patch 33 44
1513
1514# generate SourceX urls from range START STOP
1515# Format can be SINGLE format char of %e, %f, %g, see seq(1)
1516# The sources start from 10000
1517%patchset_source(f:b:) %(
1518 base=%{-b*}%{!-b*:10000};
1519 start=$(expr $base + %1);
1520 end=$(expr $base + %{?2}%{!?2:%{1}});
1521 # we need to call seq twice as it doesn't allow two formats
1522 seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
1523 seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
1524 paste %{tmpdir}/__ps{1,2};
1525 rm -f %{tmpdir}/__ps{1,2};
1526) \
1527%{nil}
1528
1529# apply sources from %patchset_source
1530# -p specify -pX for %patch line
1531# -b base offset: defaults to 10000
1532%patchset_patch(f:p:b:) %(
1533 base=%{-b*}%{!-b*:10000};
1534 start=$(expr $base + %1);
1535 end=$(expr $base + %{?2}%{!?2:%{1}});
1536 echo ": patchset_patch %1%{?2: to %2}";
1537 seq -f 'patch%g %{-p*:-p%{-p*}}' $start $end | sed -e s,^,%%,;
1538) \
1539%{nil}
1540
1541# browser plugins v2
1542# Author: Elan Ruusamäe <glen@pld-linux.org>
1543#
1544# Usage:
1545# %browser_plugins_add_browser <name> -p <plugindir>
1546#
1547# <name> (required) -- name of the browser. usually %{name}.
1548# -p <plugindir> (required) -- in what directory browser searches for its plugins.
1549# -b -- default blacklists
1550# -a <arch> override arch
1551#
1552# Example:
1553# %browser_plugins_add_browser %{name} -p %{_firefoxdir}/plugins
1554
1555%_browserpluginsconfdir /etc/browser-plugins
1556%_browserpluginsdir %{_libdir}/browser-plugins
1557%update_browser_plugins /usr/sbin/update-browser-plugins || :
1558
1559%browser_plugins_add_browser(p:b:a:) \
1560 browser=%1.%{!-a:%{_target_base_arch}}%{-a*} \
1561 install -d $RPM_BUILD_ROOT%{_browserpluginsconfdir}/{blacklist,browsers}.d \
1562 ln -s %{-p*} $RPM_BUILD_ROOT%{_browserpluginsconfdir}/browsers.d/$browser \
1563 blacklist_file=$RPM_BUILD_ROOT%{_browserpluginsconfdir}/blacklist.d/$browser.blacklist \
1564 echo '# This file format is shell globs at base dir of plugindir' > $blacklist_file \
1565 %{-b:cat >> $blacklist_file %{-b*}} \
1566%{nil}
1567
1568# Helper for LUA.
1569# split string separated by space into quoted list
1570#
1571# Author: Elan Ruusamäe <glen@pld-linux.org>
1572#
1573# %__lua_split /bin/sh /bin/pdksh -> "/bin/sh", "/bin/pdksh"
1574%__lua_split() %(echo "%*" | awk '{for (i=1;i<=NF;i++) printf("\\"%%s\\"%%s", $i, i == NF ? "" : ", ")}')
1575
1576# adjust /etc/shells by adding and removing shells from there
1577# Author: Elan Ruusamäe <glen@pld-linux.org>
1578#
1579# Usage:
1580# %post -p <lua>
1581# %lua_add_etc_shells /bin/sh /bin/pdksh
1582#
1583# %preun -p <lua>
1584# if arg[2] == 0 then
1585# %lua_remove_etc_shells /bin/bash /bin/rbash
1586# end
1587#
1588# Requirements:
1589# BuildRequires: rpmbuild(macros) >= 1.462
1590#
1591
1592%lua_add_etc_shells() \
1593t = {}\
1594f = io.open("/etc/shells", "r")\
1595if f then\
1596 for l in f:lines() do t[l]=l; end\
1597 f:close()\
1598end\
1599for _, s in ipairs({%{expand:%%__lua_split %*}}) do\
1600 if not t[s] then\
1601 print("Adding "..s.." to /etc/shells")\
1602 f = io.open("/etc/shells", "a"); f:write(s.."\\n"); f:close()\
1603 end\
1604end\
1605%{nil}
1606
1607%lua_remove_etc_shells() \
1608t = {}\
1609f = io.open("/etc/shells", "r")\
1610if f then\
1611 for l in f:lines() do t[l]=l; end\
1612 f:close()\
1613end\
1614for _, l in pairs({%{expand:%%__lua_split %*}}) do\
1615 print("Removing "..l.." from /etc/shells")\
1616 t[l] = nil\
1617end\
1618s=""\
1619for _, l in pairs(t) do\
1620 s=s..l.."\\n"\
1621end\
1622io.open("/etc/shells", "w"):write(s)\
1623%{nil}
1624
1625# Backwards compat. Use of %lua_ prefixed macros is preferred as these are cleaner to read.
1626#
1627# Author: Elan Ruusamäe <glen@pld-linux.org>
1628#
1629# Usage:
1630# %post -p %add_etc_shells -p /bin/sh /bin/pdksh
1631# %preun -p %remove_etc_shells -p /bin/sh /bin/pdksh
1632#
1633# -p (optional) -- specifies that result is embeded %post script (prepends <lua> as first line)
1634#
1635# Requirements:
1636# BuildRequires: rpmbuild(macros) >= 1.429
1637#
1638%add_etc_shells(p) %{-p:<lua>}\
1639%{expand:%%lua_add_etc_shells %*}\
1640%{nil}
1641
1642%remove_etc_shells(p) %{-p:<lua>}\
1643%{-p:if arg[2] == 0 then}\
1644%{expand:%%lua_remove_etc_shells %*}\
1645%{-p:end} \
1646%{nil}
1647
1648# Check syntax for Python files
1649#
1650# Author: Elan Ruusamäe <glen@pld-linux.org>
1651# Author: Arkadiusz Miśkiewicz <arekm@pld-linux.org>
1652#
1653# Usage:
1654# %py_lint src
1655#
1656# Requirements:
1657# BuildRequires: python
1658# BuildRequires: rpmbuild(macros) >= 1.469
1659
1660%py_lint() \
1661__py_lint() { \
1662find "$@" -type f -name '*.py' | python -c ' \
1663import sys \
1664import compiler \
1665\
1666err = 0\
1667for f in sys.stdin: \
1668 fd = open(f.strip()) \
1669 c = fd.read() \
1670 fd.close() \
1671 try: \
1672 compiler.parse(c) \
1673 except SyntaxError, e: \
1674 print "py_lint: %s: %s" % (f.strip(), e) \
1675 err = err + 1\
1676\
1677if err: \
1678 print >> sys.stderr, "\\npy_lint: ERROR: Syntax errors in %d files.\\n" % err \
1679 sys.exit(1) \
1680else: \
1681 print >> sys.stderr, "py_lint: Found no syntax errors." \
1682' \
1683}; __py_lint %* \
1684%{nil}
1685
1686# vim:ts=4 sw=4 noet syn=spec
This page took 0.078406 seconds and 4 git commands to generate.